'use strict';

exports.__esModule = true;
exports.createRequestInfo = createRequestInfo;
exports.createResponseInfo = createResponseInfo;
exports.prepareEventData = prepareEventData;
function createRequestInfo(ctx, opts) {
    return {
        requestId: ctx.requestId,
        userAgent: opts.headers['user-agent'],
        url: opts.url,
        method: opts.method.toLowerCase(),
        isAjax: ctx.isXhr || ctx.isFetch,
        headers: opts.headers,
        body: opts.body,
        sessionId: ctx.session.id
    };
}

function createResponseInfo(ctx) {
    return {
        requestId: ctx.requestId,
        headers: ctx.destRes.headers,
        body: ctx.nonProcessedDestResBody,
        statusCode: ctx.destRes.statusCode,
        sessionId: ctx.session.id
    };
}

function prepareEventData(eventData, opts) {
    var clonedEventData = Object.assign({}, eventData);

    if (!opts.includeHeaders) delete clonedEventData.headers;

    if (!opts.includeBody) delete clonedEventData.body;

    return clonedEventData;
}