'use strict';

exports.__esModule = true;

exports.default = function (script) {
    return `
        <script class="${_className2.default.selfRemovingScript}">
            (function () {
                ${script}

                var currentScript = document.currentScript;

                /* NOTE: IE11 doesn't support the 'currentScript' property */
                if (!currentScript) {
                    var scripts;
                    var hammerhead;

                    try {
                        hammerhead = parent["${_internalProperties2.default.hammerhead}"] || window["${_internalProperties2.default.hammerhead}"];
                    }
                    catch (e) {
                        hammerhead = window["${_internalProperties2.default.hammerhead}"];
                    }
                    
                    try {
                        scripts = hammerhead ? hammerhead.nativeMethods.documentScriptsGetter.call(document) : document.scripts;
                    } catch (e) {
                        scripts = document.scripts;
                    }

                    currentScript = scripts[scripts.length - 1];
                }

                currentScript.parentNode.removeChild(currentScript);
            })();
        </script>
    `.replace(/\n\s*|\/\*[\S\s]*?\*\//g, '');
};

var _className = require('../shadow-ui/class-name');

var _className2 = _interopRequireDefault(_className);

var _internalProperties = require('../processing/dom/internal-properties');

var _internalProperties2 = _interopRequireDefault(_internalProperties);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = exports['default']; // -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------